VSTGUI: CParamDisplay Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Groups Pages
Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
CParamDisplay Class Reference
Views

a parameter display More...

Inheritance diagram for CParamDisplay:

## Public Member Functions
| CParamDisplay (const CRect &size, CBitmap *background=nullptr, int32_t style=0)
| CParamDisplay (const CParamDisplay &paramDisplay)
void | draw (CDrawContext *pContext) override
| called if the view should draw itself
bool | getFocusPath (CGraphicsPath &outPath) override
| the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor()
bool | removed (CView *parent) override
| view is removed from parent view
CBaseObject * | newCopy () const override
Public Member Functions inherited from CControl
| CControl (const CRect &size, IControlListener *listener=nullptr, int32_t tag=0, CBitmap *pBackground=nullptr)
| CControl (const CControl &c)
bool | isDirty () const override
| check if view is dirty
void | setDirty (bool val=true) override
| set the view to dirty so that it is redrawn in the next idle.
bool | drawFocusOnTop () override
| draw focus before view will be drawn or afterwards
virtual void | setValue (float val)
virtual float | getValue () const
virtual void | setValueNormalized (float val)
virtual float | getValueNormalized () const
virtual void | setMin (float val)
virtual float | getMin () const
virtual void | setMax (float val)
virtual float | getMax () const
float | getRange () const
virtual void | setOldValue (float val)
virtual float | getOldValue () const
virtual void | setDefaultValue (float val)
virtual float | getDefaultValue () const
virtual void | bounceValue ()
virtual void | valueChanged ()
| notifies listener and dependent objects
virtual void | setTag (int32_t val)
virtual int32_t | getTag () const
virtual void | beginEdit ()
virtual void | endEdit ()
bool | isEditing () const
virtual IControlListener * | getListener () const
| get main listener
virtual void | setListener (IControlListener *l)
| set main listener
void | registerControlListener (IControlListener *listener)
| register a sub listener
void | unregisterControlListener (IControlListener *listener)
| unregister a sub listener
virtual void | setWheelInc (float val)
virtual float | getWheelInc () const
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
void | setSubviewState (bool state)
bool | isSubview () const
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes
void | setTooltipText (UTF8StringPtr text)
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
virtual void | dispatchEvent (Event &event)
| dispatch an event
virtual void | onMouseDownEvent (MouseDownEvent &event)
| called when a mouse down event occurs
virtual void | onMouseMoveEvent (MouseMoveEvent &event)
| called when a mouse move event occurs
virtual void | onMouseUpEvent (MouseUpEvent &event)
| called when a mouse up event occurs
virtual void | onMouseCancelEvent (MouseCancelEvent &event)
| called when mouse tracking should be canceled
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view
virtual void | onMouseWheelEvent (MouseWheelEvent &event)
| called when a mouse wheel event occurs
virtual void | onZoomGestureEvent (ZoomGestureEvent &event)
| called when a zoom gesture event occurs
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer.
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
virtual bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons)
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| A drag can only be started from within onMouseDown or onMouseMove.
virtual SharedPointer < IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown
virtual void | onKeyboardEvent (KeyboardEvent &event)
| called when a keyboard event is dispatched to this view
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
CCoord | getHeight () const
| get the height of the view
CCoord | getWidth () const
| get the width of the view
virtual void | setViewSize (const CRect &rect, bool invalid=true)
| set views size
const CRect & | getViewSize () const
| read only access to view size
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags
int32_t | getAutosizeFlags () const
| get autosize flags
virtual bool | sizeToFit ()
| resize view to optimal size
virtual void | looseFocus ()
| called if view should loose focus
virtual void | takeFocus ()
| called if view should take focus
virtual bool | wantsFocus () const
| check if view supports focus
virtual void | setWantsFocus (bool state)
| set focus support on/off
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute
virtual void | setBackground (CBitmap *background)
| set the background image of this view
CBitmap * | getBackground () const
| get the background image of this view
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state.
virtual void | setTransparency (bool val)
| set views transparent state
bool | getTransparency () const
| get views transparent state
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view
float | getAlphaValue () const
| get alpha value
virtual bool | attached (CView *parent)
| view is attached to a parent view
bool | isAttached () const
| is view attached to a parentView
CView * | getParentView () const
| get parent view
CFrame * | getFrame () const
| get frame
virtual VSTGUIEditorInterface * | getEditor () const
| get editor
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view
template<typename T >
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms
template<typename T >
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
| called if the view should draw itself
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid
virtual void | invalid ()
| mark whole view as invalid
virtual void | setVisible (bool state)
| set visibility state
bool | isVisible () const
| get visibility state
virtual void | onIdle ()
| called on idle when view wants idle
void | setWantsIdle (bool state)
| enable/disable onIdle() callback
bool | wantsIdle () const
| returns if the view wants idle callback or not
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexceptoverride=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
virtual CMessageResult | notify ([[maybe_unused]] CBaseObject *sender,[[maybe_unused]] IdStringPtr message)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
Public Member Functions inherited from IFocusDrawing
virtual | ~IFocusDrawing () noexcept=default

## Protected Types
enum | StyleEnum { StyleShadowText = 0, Style3DIn, Style3DOut, StyleNoText, StyleNoDraw, StyleRoundRect, StyleNoFrame, StyleAntialias, LastStyle }
enum | StylePrivate { kAntialias = 1 << StyleAntialias }

## Protected Member Functions
| ~CParamDisplay () noexceptoverride
virtual void | drawBack (CDrawContext *pContext, CBitmap *newBack=nullptr)
virtual void | drawPlatformText (CDrawContext *pContext, IPlatformString *string)
virtual void | drawPlatformText (CDrawContext *pContext, IPlatformString *string, const CRect &size)
virtual void | drawStyleChanged ()
Protected Member Functions inherited from CControl
| ~CControl () noexceptoverride
Protected Member Functions inherited from CView
| ~CView () noexceptoverride
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## Protected Attributes
ValueToStringFunction2 | valueToStringFunction
CHoriTxtAlign | horiTxtAlign
int32_t | style
uint8_t | valuePrecision
CFontRef | fontID
CColor | fontColor
CColor | backColor
CColor | frameColor
CColor | shadowColor
CPoint | textInset
CPoint | shadowTextOffset {1., 1.}
CPoint | backOffset
CCoord | roundRectRadius
CCoord | frameWidth
double | textRotation
Protected Attributes inherited from CControl
IControlListener * | listener
int32_t | tag
float | value

## CParamDisplay Methods
enum | Style { kShadowText = 1 << StyleShadowText, k3DIn = 1 << Style3DIn, k3DOut = 1 << Style3DOut, kNoTextStyle = 1 << StyleNoText, kNoDrawStyle = 1 << StyleNoDraw, kRoundRectStyle = 1 << StyleRoundRect, kNoFrame = 1 << StyleNoFrame }
using | ValueToStringUserData = CParamDisplay
using | ValueToStringFunction = std::function< bool(float value, char utf8String[256], CParamDisplay *display)>
using | ValueToStringFunction2 = std::function< bool(float value, std::string &result, CParamDisplay *display)>
virtual void | setFont (CFontRef fontID)
const CFontRef | getFont () const
virtual void | setFontColor (CColor color)
CColor | getFontColor () const
virtual void | setBackColor (CColor color)
CColor | getBackColor () const
virtual void | setFrameColor (CColor color)
CColor | getFrameColor () const
virtual void | setShadowColor (CColor color)
CColor | getShadowColor () const
virtual void | setShadowTextOffset (const CPoint &offset)
CPoint | getShadowTextOffset () const
virtual void | setAntialias (bool state)
bool | getAntialias () const
virtual void | setHoriAlign (CHoriTxtAlign hAlign)
CHoriTxtAlign | getHoriAlign () const
virtual void | setTextInset (const CPoint &p)
CPoint | getTextInset () const
virtual void | setTextRotation (double angle)
double | getTextRotation () const
virtual void | setRoundRectRadius (const CCoord &radius)
CCoord | getRoundRectRadius () const
virtual void | setFrameWidth (const CCoord &width)
CCoord | getFrameWidth () const
void | setValueToStringFunction (const ValueToStringFunction &valueToStringFunc)
void | setValueToStringFunction (ValueToStringFunction &&valueToStringFunc)
void | setValueToStringFunction2 (const ValueToStringFunction2 &valueToStringFunc)
void | setValueToStringFunction2 (ValueToStringFunction2 &&valueToStringFunc)
virtual void | setStyle (int32_t val)
int32_t | getStyle () const
virtual void | setPrecision (uint8_t precision)
uint8_t | getPrecision () const
virtual void | setBackOffset (const CPoint &offset)
const CPoint & | getBackOffset () const
void | copyBackOffset ()

## Additional Inherited Members
Public Types inherited from CControl
using | CheckDefaultValueEventFuncT = bool(*)(CControl *, MouseDownEvent &)
using | CheckDefaultValueFuncT = bool(*)(CControl *, CButtonState)
Static Public Attributes inherited from CControl
static CheckDefaultValueEventFuncT | CheckDefaultValueEventFunc
| Function to check if a mouse down event should reset the value to its default value for a *control.
static int32_t | kZoomModifier = kShift
| zoom modifier key, per default is the shift key
static int32_t | kDefaultValueModifier = kControl
static CheckDefaultValueFuncT | CheckDefaultValueFunc
Static Protected Member Functions inherited from CControl
static int32_t | mapVstKeyModifier (int32_t vstModifier)

## Detailed Description

a parameter display

Define a rectangle view where a text-value can be displayed with a given font and color. The user can specify its convert function (from float to char) by default the string format is "%2.2f". The text-value is centered in the given rect.

## Member Typedef Documentation

using ValueToStringFunction = std::function<bool (float value, char utf8String[256], CParamDisplay* display)>

using ValueToStringFunction2 = std::function<bool (float value, std::string& result, CParamDisplay* display)>

using ValueToStringUserData = CParamDisplay

## Member Enumeration Documentation

enum Style

Enumerator
kShadowText |
k3DIn |
k3DOut |
kNoTextStyle |
kNoDrawStyle |
kRoundRectStyle |
kNoFrame |

enum StyleEnum
| protected

Enumerator
StyleShadowText |
Style3DIn |
Style3DOut |
StyleNoText |
StyleNoDraw |
StyleRoundRect |
StyleNoFrame |
StyleAntialias |
LastStyle |

enum StylePrivate
| protected

Enumerator
kAntialias |

## Constructor & Destructor Documentation

CParamDisplay | ( | const CRect & | size,
|  | CBitmap * | background = `nullptr`,
|  | int32_t | style = `0`
| ) |  |

CParamDisplay | ( | const CParamDisplay & | paramDisplay | ) |

~CParamDisplay | ( |  | ) |
| overrideprotectednoexcept

## Member Function Documentation

void copyBackOffset | ( |  | ) |

void draw | ( | CDrawContext * | pContext | ) |
| overridevirtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Implements CControl.

Reimplemented in CTextEdit, CTextLabel, CSearchTextEdit, and CXYPad.

void drawBack | ( | CDrawContext * | pContext,
|  | CBitmap * | newBack = `nullptr`
| ) |  |
| protectedvirtual

Reimplemented in CXYPad.

void drawPlatformText | ( | CDrawContext * | pContext,
|  | IPlatformString * | string
| ) |  |
| protectedvirtual

void drawPlatformText | ( | CDrawContext * | pContext,
|  | IPlatformString * | string,
|  | const CRect & | size
| ) |  |
| protectedvirtual

void drawStyleChanged | ( |  | ) |
| protectedvirtual

Reimplemented in CTextLabel.

bool getAntialias | ( |  | ) | const
| inline

CColor getBackColor | ( |  | ) | const
| inline

const CPoint& getBackOffset | ( |  | ) | const
| inline

bool getFocusPath | ( | CGraphicsPath & | outPath | ) |
| overridevirtual

the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor()

Reimplemented from CControl.

const CFontRef getFont | ( |  | ) | const
| inline

CColor getFontColor | ( |  | ) | const
| inline

CColor getFrameColor | ( |  | ) | const
| inline

CCoord getFrameWidth | ( |  | ) | const
| inline

CHoriTxtAlign getHoriAlign | ( |  | ) | const
| inline

uint8_t getPrecision | ( |  | ) | const
| inline

CCoord getRoundRectRadius | ( |  | ) | const
| inline

CColor getShadowColor | ( |  | ) | const
| inline

CPoint getShadowTextOffset | ( |  | ) | const
| inline

int32_t getStyle | ( |  | ) | const

CPoint getTextInset | ( |  | ) | const
| inline

double getTextRotation | ( |  | ) | const
| inline

CBaseObject* newCopy | ( |  | ) | const
| inlineoverridevirtual

Implements CControl.

Reimplemented in CTextEdit, and CTextLabel.

bool removed | ( | CView * | parent | ) |
| overridevirtual

view is removed from parent view

Parameters

  parent | parent view

Returns
  true if view successfully removed from parent

Reimplemented from CView.

virtual void setAntialias | ( | bool | state | ) |
| inlinevirtual

void setBackColor | ( | CColor | color | ) |
| virtual

void setBackOffset | ( | const CPoint & | offset | ) |
| virtual

void setFont | ( | CFontRef | fontID | ) |
| virtual

void setFontColor | ( | CColor | color | ) |
| virtual

void setFrameColor | ( | CColor | color | ) |
| virtual

void setFrameWidth | ( | const CCoord & | width | ) |
| virtual

void setHoriAlign | ( | CHoriTxtAlign | hAlign | ) |
| virtual

void setPrecision | ( | uint8_t | precision | ) |
| virtual

void setRoundRectRadius | ( | const CCoord & | radius | ) |
| virtual

void setShadowColor | ( | CColor | color | ) |
| virtual

void setShadowTextOffset | ( | const CPoint & | offset | ) |
| virtual

void setStyle | ( | int32_t | val | ) |
| virtual

void setTextInset | ( | const CPoint & | p | ) |
| virtual

void setTextRotation | ( | double | angle | ) |
| virtual

Reimplemented in CTextEdit.

void setValueToStringFunction | ( | const ValueToStringFunction & | valueToStringFunc | ) |

void setValueToStringFunction | ( | ValueToStringFunction && | valueToStringFunc | ) |

void setValueToStringFunction2 | ( | const ValueToStringFunction2 & | valueToStringFunc | ) |

void setValueToStringFunction2 | ( | ValueToStringFunction2 && | valueToStringFunc | ) |

## Member Data Documentation

CColor backColor
| protected

CPoint backOffset
| protected

CColor fontColor
| protected

CFontRef fontID
| protected

CColor frameColor
| protected

CCoord frameWidth
| protected

CHoriTxtAlign horiTxtAlign
| protected

CCoord roundRectRadius
| protected

CColor shadowColor
| protected

CPoint shadowTextOffset {1., 1.}
| protected

int32_t style
| protected

CPoint textInset
| protected

double textRotation
| protected

uint8_t valuePrecision
| protected

ValueToStringFunction2 valueToStringFunction
| protected

The documentation for this class was generated from the following files:

- cparamdisplay.h
- cparamdisplay.cpp